﻿// 指定されたフォルダ内にある画像を開いて最大サイズの画像のキャンバスにする
(function(){
    var imgList = getAllFiles(["*.psd", "*.tif", "*.jpg", "*.jpeg"]);
    var maxWidth = 0;
    var maxHeight = 0;
    app.displayDialogs = DialogModes.NO;    // ダイアログを出さないようにする
    var saveUnit = preferences.rulerUnits;	// 単位を保存
    preferences.rulerUnits = Units.PIXELS;	// 単位をピクセルに設定
    for(var i=0; i<imgList.length; i++){
        app.open(imgList[i]);
        var w = parseFloat(app.activeDocument.width);
        var h = parseFloat(app.activeDocument.height);
        $.writeln(w+","+h);
        if (w > maxWidth){ maxWidth = w; }
        if (h > maxHeight){ maxHeight = h; }
        activeDocument.close(SaveOptions.DONOTSAVECHANGES);
    }
    $.writeln("-----------------");
    $.writeln(maxWidth+","+maxHeight);
    for(var i=0; i<imgList.length; i++){
        app.open(imgList[i]);
        app.activeDocument.resizeCanvas(maxWidth, maxHeight, AnchorPosition.MIDDLECENTER);
        activeDocument.close(SaveOptions.SAVECHANGES);  // 保存する
    }
    preferences.rulerUnits = saveUnit;	// 単位を元に戻す
})();
// File Library
function getAllFiles(fileTypes, basePath,options){
	options = options || {};
	if(!basePath){
		basePath = Folder.selectDialog("フォルダを選択してください");
		if (!basePath){ return; }	// キャンセルされた場合は処理しない
	}
	var allList = [];
	// パラメータが文字の場合
	if (typeof(fileTypes) == "string"){
		getFileList(new Folder(basePath), fileTypes);
		return toJapanese(allList, options.japanese);
	}
	// パラメータが配列の場合
	if (fileTypes.push){
		for(var i=0; i<fileTypes.length; i++){
			getFileList(new Folder(basePath), fileTypes[i]);
		}
		return toJapanese(allList, options.japanese);
	}
	function getFileList(currentFolder, fileType){
		var fileList = currentFolder.getFiles(fileType);
		var fileList2 = currentFolder.getFiles("*");	// Sub Folder
		allList = allList.concat(fileList);
		for(var i=0; i<fileList2.length; i++){
			if (fileList2[i].getFiles){
				if (fileList2[i].name.charAt(0) == "."){ continue; }
				getFileList(fileList2[i], fileType);	// フォルダがある限り繰り返し
			}
		}
	}
	// 日本語に変換(nameJ, fullNameJ)
	function toJapanese(fileList, flag){
		if (!flag){ return fileList; }
		for(var i=0; i<fileList.length; i++){
			fileList[i].nameJ = File.decode(fileList[i].name);
			fileList[i].fullNameJ = File.decode(fileList[i].fullName);
		}
		return fileList;
	}
}
